# Official framework image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/node/tags/
image: node:6

before_script:
  - npm install
  - node -v
  - npm -v

# This folder is cached between builds
# http://docs.gitlab.com/ce/ci/yaml/README.html#cache
# https://gitlab.com/gitlab-org/gitlab-ce/issues/12963
cache:
  untracked: true
  key: "$CI_BUILD_REF_NAME"
  paths:
    - node_modules/
    - build/

# Set environement variable
variables:
  RPC_HOST: "ruimarinho__bitcoin-core"

stages:
  - build
  - lint
  - test

build:
  stage: build
  script:
    - npm run build

lint:
  stage: lint
  script:
    - npm run lint

test:unit:
  stage: test
  script:
    - npm run build
    - npm run test:run

test:integration:
  stage: test
  services:
  - name: ruimarinho/bitcoin-core:0.15-alpine
    entrypoint: ["./entrypoint.sh", "-regtest=1", "-rpcpassword=test", "-rpcuser=test", "-rpcbind=0.0.0.0:18332", "-rpcallowip=0.0.0.0/0", "-printtoconsole", "-server"]
  script:
    - "curl -o /dev/null --user test:test --data-binary '{\"jsonrpc\": \"1.0\", \"id\":\"curltest\", \"method\": \"generate\", \"params\": [1001] }' -H 'content-type: text/plain;' -X POST http://ruimarinho__bitcoin-core:18332/"
    - npm run build
    - npm run integration:run
